<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */

namespace Twilio\Rest\FlexApi\V1;

use Twilio\Exceptions\TwilioException;
use Twilio\ListResource;
use Twilio\Options;
use Twilio\Values;
use Twilio\Version;

/**
 * PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
 */
class InsightsSettingsAnswerSetsList extends ListResource {
    /**
     * Construct the InsightsSettingsAnswerSetsList
     *
     * @param Version $version Version that contains the resource
     */
    public function __construct(Version $version) {
        parent::__construct($version);

        // Path Solution
        $this->solution = [];

        $this->uri = '/Insights/QM/Settings/AnswerSets';
    }

    /**
     * Fetch the InsightsSettingsAnswerSetsInstance
     *
     * @param array|Options $options Optional Arguments
     * @return InsightsSettingsAnswerSetsInstance Fetched
     *                                            InsightsSettingsAnswerSetsInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch(array $options = []): InsightsSettingsAnswerSetsInstance {
        $options = new Values($options);

        $headers = Values::of(['Token' => $options['token'], ]);

        $payload = $this->version->fetch('GET', $this->uri, [], [], $headers);

        return new InsightsSettingsAnswerSetsInstance($this->version, $payload);
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string {
        return '[Twilio.FlexApi.V1.InsightsSettingsAnswerSetsList]';
    }
}